- name: M4 exercise playbook
  hosts: M4ManagedNode
  remote_user: ec2-user

  vars_prompt:
    - name: trello_api_key
      prompt: Please input trello API Key
      private: no

    - name: trello_token
      prompt: Please input trello token

    - name: todo_list_id
      prompt: Please input todo list id

    - name: done_list_id
      prompt: Please input done list id

    - name: board_id
      prompt: Please input board id

  tasks:
    - name: Install Git and python3
      ansible.builtin.yum:
        name:
          - git
          - python3
        state: present
      become: yes
    - name: Install poetry
      ansible.builtin.shell: curl curl -sSL https://install.python-poetry.org | python3 -
      args:
        warn: no
        creates: ~/.local/bin/poetry
    - name: Create todoapp folder
      ansible.builtin.file:
        path: /opt/todoapp
        state: directory
        owner: ec2-user
        mode: "0600"
      become: yes
    - name: Checkout todo app
      ansible.builtin.git:
        repo: https://gitlab.com/amit.punpale/devops-course-starter.git
        dest: /opt/todoapp
        version: M4-Exercise-Ansible
    - name: Install project depedencies
      ansible.builtin.shell: ~/.local/bin/poetry install
      args:
        chdir: /opt/todoapp

    - name: Create the env file for the todo app
      ansible.builtin.template:
        src: /home/ec2-user/ansible/.env.j2
        dest: /opt/todoapp/.env
        owner: ec2-user
        mode: "0600"
    - name: Copy todoapp.service to systemd folder
      ansible.builtin.copy:
        src: /opt/todoapp/ansible/todoapp.service
        dest: /etc/systemd/system/todoapp.service
        remote_src: yes
        owner: ec2-user
        mode: "0600"
      become: yes
    - name: Make sure a service unit is running
      ansible.builtin.systemd:
        state: started
        name: todoapp.service
        daemon_reload: yes
      become: yes
    - name: Check if todo app is up
      uri:
        url: http://localhost:5000/
